/* FOCUS header file.

   Author : Pat Boens
   Last modification : 21 February 96 - 18:42

   This header file is necessary to all C functions that are designed
   to be called from within FoxPro.
   It has been conceived to be used in under various platforms :
   DOS, Mac, Windows.
   It follows the extend specifications of Clipper the best it can.
   Under some circumstances, it was necessary to slightly adapt
   the interface functions. However, in most cases it works
   identically !
*/

// Translation directives for various environments ///////////////////////////////////////////////
#define __WINDOWS
//////////////////////////////////////////////////////////////////////////////////////////////////

#if defined( __MAC )

 #define LONG long
 
 #define BOOL int
 #define min(a,b) (a < b ? a : b)
 
#elif defined( __WINDOWS )
 #define DLLFUNC                       _loadds _export CALLBACK
 #define EXPORT                        __declspec( dllexport )   
#elif defined( __DOS )

#elif defined( __UNIX )

#endif

// Parameters --------------------------------------------------------

#define FOXPARAMETERS                 ParamBlk FAR *Parm
#define XBASE_PARAMETERS              FOXPARAMETERS

#define INCREASE_STRING_SIZE(i)       {if(!_SetHandSize(Parm->p[i].val.ev_handle, Parm->p[i].val.ev_length+1)) _Error(182);}
#define LOCK_HANDLE(i)                {_HLock(Parm->p[i].val.ev_handle);}
#define UNLOCK_HANDLE(i)              {_HUnLock(Parm->p[i].val.ev_handle);}
#define GET_STRING_LENGTH(i)          (Parm->p[i].val.ev_length)
#define GET_STRING_HANDLE(i)          (Parm->p[i].val.ev_handle)
#define HANDLE_2_STRING(i)            ((char _far *)(_HandToPtr(Parm->p[i].val.ev_handle)))
#define HANDLE_2_STRINGZ(i)           {((char _far *)_HandToPtr(Parm->p[i].val.ev_handle))[Parm->p[i].val.ev_length] = '\0';}

#define PCOUNT()                      (Parm->pCount)
#define ISNUM(i)                      (Parm->p[i-1].val.ev_type == 'N')
#define ISINT(i)                      (Parm->p[i-1].val.ev_type == 'I')
#define ISCHAR(i)                     (Parm->p[i-1].val.ev_type == 'C')
#define ISDATE(i)                     (Parm->p[i-1].val.ev_type == 'D')
#define ISMEMO(i)                     (Parm->p[i-1].val.ev_type == 'M')
#define ISLOGICAL(i)                  (Parm->p[i-1].val.ev_type == 'L')
#define ISBYREF(i)                    (Parm->p[i-1].loc.l_type  == 'R')

#define _parni(i)                     ((int)    (Parm->p[i-1].val.ev_long  ))
#define _parnl(i)                     ((long)   (Parm->p[i-1].val.ev_long  ))
#define _pard(i)                      ((double) (Parm->p[i-1].val.ev_real  ))
#define _parnd(i)                     ((double) (Parm->p[i-1].val.ev_real  ))
#define _parl(i)                      ((int)    (Parm->p[i-1].val.ev_length))
#define _parclen(i)                             (Parm->p[i-1].val.ev_length)
#define _parc(i)                      ((char _far *)(_HandToPtr(Parm->p[i-1].val.ev_handle)))

#define _retc(x)                      _RetChar(x)
#define _retni(x)                     _RetInt(x,10)
#define _retl(x)                      _RetLogical(x)
#define _ret()                        _RetLogical(1)
#define _retnl(x)                     _RetInt(x,10)
#define _retnd(x)                     _RetFloat(x,20,4)

#define _initparc(i)                  { INCREASE_STRING_SIZE(i-1);HANDLE_2_STRINGZ(i-1);LOCK_HANDLE(i-1); }
#define _deinitparc(i)                UNLOCK_HANDLE(i-1);

// Variables ---------------------------------------------------------

#define VAR_INCREASE_HANDLE_SIZE(var) {if(!_SetHandSize(var.ev_handle, var.ev_length+1)) _MemoryError();}
#define VAR_LOCK_HANDLE(var)          {_HLock(var.ev_handle);}
#define VAR_UNLOCK_HANDLE(var)        {_HUnLock(var.ev_handle);}
#define VAR_GET_STRING_LENGTH(var)    (var.ev_length)
#define VAR_GET_STRING_HANDLE(var)    (var.ev_handle)
#define VAR_HANDLE_2_STRING(var)      ((char _far *)(_HandToPtr(var.ev_handle)))
#define VAR_HANDLE_2_STRINGZ(var)     {((char _far *)_HandToPtr(var.ev_handle))[var.ev_length] = '\0';}

#define _varclen(var)                 (var.ev_length)
#define _varc(var)                    ((char _far *)(_HandToPtr(var.ev_handle)))

#define _initvarc(var)                { VAR_INCREASE_HANDLE_SIZE(var);VAR_HANDLE_2_STRINGZ(var);VAR_LOCK_HANDLE(var); }
#define _deinitvarc(var)              UNLOCK_HANDLE(var);

// General definitions -----------------------------------------------

#define _AllocMemory(x)               _AllocHand(x)
#define _MemoryError()                _Error(182)
#define _exmgrab(x)                   _xgrab(x,mh)

#define MAX_EVENTS                    14

#define FOCUSFNC                      int

// Additional definitions -----------------------------------------------


#define FOXP_INT(i)                   ((int)(Parm->p[i].val.ev_long))
#define FOXP_LENGTH(i)                (Parm->p[i].val.ev_length)
#define FOXP_LOCK(i)                  {_HLock(Parm->p[i].val.ev_handle);}
#define FOXP_UNLOCK(i)                {_HUnLock(Parm->p[i].val.ev_handle);}
#define STRINGtoLPSZ(i)               {((char _far *)_HandToPtr(Parm->p[i].val.ev_handle))[Parm->p[i].val.ev_length] = '\0';}
#define FOXP_HSIZE(i)                 {if(!_SetHandSize(Parm->p[i].val.ev_handle, Parm->p[i].val.ev_length+1)) _Error(182);}
#define FOXP_LPSZ(i)                  ((char _far *)(_HandToPtr(Parm->p[i].val.ev_handle)))  

//// Macros
#define FOXWINDOW()                   _WhToHwnd( _WMainWindow() )

