/* Header file for files.c
   Part of FOCUS.FLL project
*/
#include "extend.h"

#define  FOCUS_NEEDS_FILETIME     1
#define  FOCUS_NEEDS_FILEDATE     2

#define  IsFile( a )              ( access( a,0 ) == 0 )

#define  YRMASK                   0xFE00
#define  YRSHIFT                  9
#define  MONMASK                  0x01E0
#define  MONSHIFT                 5
#define  DAYMASK                  0x001F
#define  DAYSHIFT                 0

#define  HRMASK                   0xF800
#define  HRSHIFT                  11
#define  MINMASK                  0x07E0
#define  MINSHIFT                 5
#define  SECMASK                  0x001F
#define  SECSHIFT                 0

#define  FW_READONLY              1
#define  FW_HIDDEN                2
#define  FW_SYSTEM                3
#define  FW_DIRECTORY             4
#define  FW_ARCHIVED              5
#define  FW_NORMALFILE            6
#define  FW_TMP                   7
#define  FW_COMPRESSED            8

char FAR *FW_keep_path( char FAR *filname,char FAR *pname );
char FAR *FW_FIL_keepdrive( char FAR *cFile,char FAR *cResult );
char FAR *FW_FIL_fullname( char FAR *cFile,char FAR *cResult );
char FAR *FW_FIL_extension( char FAR *cFile,char FAR *cResult);

FOCUSFNC FW_set_attribute( char _far *File,unsigned int Attribute );
FOCUSFNC FW_get_attribute( char _far *File );
FOCUSFNC FW_handles_left( void );
FOCUSFNC FW_mkdir( char _far *Dir );

FOCUSFNC FW_FIL_chdir( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_copy( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_copyTimes( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_del( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_drive( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_exenam( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_expand( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_ext( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_first( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_fname( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_fndexe( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_gdate( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_getatt( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_gtime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_hleft( void );
FOCUSFNC FW_FIL_iatime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_ictime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_imtime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_info( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isbof( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isdir( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_iseof( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isize( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_len( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_mkdir( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_name( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_next( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_path( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_reaini( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_rendir( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_rmdir( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_sdate( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_sectio( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_setatt( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_sethan( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_stime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_tell( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_where( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_wreain( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_wriini( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_wsecti( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_wwriin( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_open( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_close( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_ShortName( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_LongName( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_split( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isReadOnly( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isHidden( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isSystem( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isDirectory( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isArchived( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isNormal( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isTmp( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_isCompressed( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_GetFolderLocation( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_CreateLink( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_ReadAllSections( XBASE_PARAMETERS );

UINT GetPrivateProfileSections( LPSTR lpOutBuf,UINT cbMax,LPSTR lpszFile );
LPSTR FW_FindEndOfLine( LPSTR lpLine,LPSTR lpEOF );
FOCUSFNC FW_FIL_CompareTime( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_FileType( XBASE_PARAMETERS );
FOCUSFNC FW_FIL_owner( XBASE_PARAMETERS );
